// Abacus -  
// :
// www.prog4all.ru
// pdp8dec@gmail.com, prog4allru@gmail.com
// icq: 338488305

import java.io.*;
import java.util.*;

public class AbacusComputer {
    private ArrayList <String> src = new ArrayList <String> ();

    public AbacusComputer () {
        String fName = getSourceFileName ();
        if (fName.length () == 0) {
               System.err.println ("Empty file name");
               System.exit (0);
        }
        if (! loadSource (fName)) {
            System.exit (0);
        }
        if (src.size () == 0) {
           System.err.println ("File is empty");
           System.exit (0);
        } else {
            Parser p = new Parser ();
            p.init (src);
        }
    }

    //    
    private String getSourceFileName () {
        BufferedReader in = new BufferedReader (new InputStreamReader (System.in));
        String str = "";
        try {
            System.out.printf ("ABACUS COMPUTER, 2014 (www.prog4all.ru)\n");
            System.out.printf ("ENTER FILE NAME: ");
            str = in.readLine ().trim ();
        }
        catch (IOException ioe) {}
        return str;
    }

    //    
    private boolean loadSource (String fileName) {
        File file = new File (fileName);
        try {
            Scanner in = new Scanner (new FileReader (file));
            while (in.hasNextLine ()) {
                src.add (in.nextLine ().replace ('\t', ' ').toUpperCase ().trim ());
            }
            in.close ();
            return true;
        }
        catch (IOException ioe) {
            System.err.println ("File not found");
        }
        return false;
    }

    //  
    public static void main (String[] args) {
        AbacusComputer abc = new AbacusComputer ();
    }
}
